## bornagain 23.0

=== CMakeLists.txt ===
###########################################################################
# top-level CMakeLists.txt for building BornAgain
############################################################################

### CMake configuration

cmake_minimum_required(VERSION 3.20 FATAL_ERROR)
if (CMAKE_VERSION GREATER_EQUAL 3.30)
    cmake_policy(SET CMP0167 OLD)
    # Old policy uses FindBoost.cmake provided by CMake, which is deprecated.
    # New policy uses BoostConfig.cmake provided by Boost.  It returns targets
    # Boost::ProgramOptions etc instead of library paths.  We still have to find
    # out how replace the configure_file command in MakePythonWheel.cmake.
    # See https://jugit.fz-juelich.de/mlz/bornagain/-/issues/1074.
endif()
if (CMAKE_VERSION GREATER_EQUAL 3.31)
    cmake_policy(SET CMP0175 NEW)
endif()
if (CMAKE_VERSION GREATER_EQUAL 3.31)
    cmake_policy(SET CMP0177 OLD)
    # New behavior, introduced in CMake 3.31, normalizes all DESTINATION values
    # given in any form of the install() command.
    # Conversion to NEW behavior postponed until we require CMake >= 3.31.
endif()

set(CMAKE_MODULE_PATH
    ${CMAKE_SOURCE_DIR}
    ${CMAKE_SOURCE_DIR}/cmake/find)
set(CONFIGURABLES_DIR ${CMAKE_SOURCE_DIR}/cmake/configurables)

include(cmake/BornAgain/Git)
message(STATUS "Git branch '${GIT_BRANCH}' at commit ${GIT_COMMIT}, tag: '${GIT_TAG}'")

include(cmake/commons/PreventInSourceBuilds)

### Project settings

project(BornAgain
    VERSION 23.0 # will always remain binary; minor equals patch-level
    DESCRIPTION "BornAgain: simulate and fit reflectometry and grazing-incidence scattering."
    HOMEPAGE_URL https://www.bornagainproject.org
    LANGUAGES CXX)

set(CMAKE_CXX_STANDARD 20)

### Options

# options that are on by default (switch off for accelerated builds of limited scope)
option(BORNAGAIN_PYTHON "Build with Python support" ON)
option(BA_GUI "Build a graphical user interface" ON)
option(BA_TIFF_SUPPORT "Tiff files read/write support" ON)
option(BA_TESTS "Build tests" ON)
option(BA_DOCS "Build documentation" ON)
option(BA_PY_PACK "Build BornAgain Python wheel" ON)

# options that are off by default (switch on for additional functionality)
option(CONFIGURE_BINDINGS "Generate python bindings during build (requires swig)" OFF)
option(CONFIGURE_EXAMPLES "Configure examples (requires ruby)" OFF)
option(CONFIGURE_DOXY "Configure Doxygen source documentation" OFF)
option(ALLCONFIG "Regenerate Py wrappers, examples, Doxyfiles" OFF)
option(ZERO_TOLERANCE "Terminate compilation on warnings" OFF)
option(DEVELOPER_CHECKS "Checks required from developers but not from external users" OFF)
option(DEV "Development: turns ALLCONFIG, ZERO_TOLERANCE, DEVELOPER_CHECKS on" OFF)
option(BA_COVERAGE "Build with test coverage information" OFF)
option(BA_DEBUG_OPTIMIZATION "Build with debug optimization (gcc only)" OFF)
option(BA_TIDY "Invokes clang-tidy" OFF)
option(ALGORITHM_DIAGNOSTIC "Let some algorithms set diagnostic variables" OFF)
option(BA_CPP_API "Install header files" OFF)
option(BA_3ARCH
    "Reduced tolerance for persistence tests on architectures not covered by maintainer CI" OFF)

# options with non-boolean value

set(SEARCH_PYTHON_PATH "" CACHE INTERNAL "Search path for Python platform to be used for packaging")
string(STRIP "${SEARCH_PYTHON_PATH}" SEARCH_PYTHON_PATH)

# options that set other options

if(DEV)
    set(ALLCONFIG ON)
    set(ZERO_TOLERANCE ON)
    set(DEVELOPER_CHECKS ON)
endif()
if(ALLCONFIG)
    set(CONFIGURE_BINDINGS ON)
    set(CONFIGURE_EXAMPLES ON)
    set(CONFIGURE_DOXY ON)
    # TODO what about targets 'figures', 'excopy'? see Tests/Examples/CMakeLists.txt
    # TODO what about target 'src_graphs'? see Doc/graph/CMakeLists.txt
endif()

# check compatibility of options

if(BA_TIDY)
    if (BORNAGAIN_PYTHON)
        message(FATAL_ERROR "BA_TIDY is incompatible with BORNAGAIN_PYTHON")
    endif()
    if(NOT CMAKE_CXX_COMPILER_ID MATCHES "Clang")
        message(FATAL_ERROR "BA_TIDY requires compiler Clang")
    endif()
endif()

if(BA_TESTS AND NOT BA_PY_PACK)
    message(FATAL_ERROR "Tests need the BA Python package, hence BA_PY_PACK must be ON.")
endif()

### Generator type (Release|Debug)

# Show info about generator type; set CMAKE_BUILD_TYPE if not given
if(CMAKE_CONFIGURATION_TYPES)
    message(STATUS "Generator type: Multi-configuration generator")
else()
    message(STATUS "Generator type: Single-configuration generator")
endif()
message("    CMAKE_CONFIGURATION_TYPES: ${CMAKE_CONFIGURATION_TYPES}")
# The following is not correct/does not have any effect for multi-configuration generators.
# But when correcting this, be aware that CMAKE_BUILD_TYPE is used in more scripts!
if(NOT CMAKE_BUILD_TYPE)
    set(CMAKE_BUILD_TYPE Release CACHE STRING "" FORCE)
    message("    CMAKE_BUILD_TYPE type not given - forced to 'Release'")
else()
    string(TOUPPER "${CMAKE_BUILD_TYPE}" _upper_build_type)
    set(BUILD_${_upper_build_type} 1)
endif()
message("    CMAKE_BUILD_TYPE: ${CMAKE_BUILD_TYPE}")
configure_file("${PROJECT_SOURCE_DIR}/cmake/configurables/config_build.h.in"
    "${PROJECT_BINARY_DIR}/inc/config_build.h"
    @ONLY)


### Configure tests

if(BA_TESTS)
    # GoogleTest: `gtest_discover_tests` discovers tests by asking the _compiled test executable_
    # to enumerate its tests. `PRE_TEST` delays test discovery until just prior to test execution;
    # this avoids calling the executables during the build phase.
    set(CMAKE_GTEST_DISCOVER_TESTS_DISCOVERY_MODE PRE_TEST)

    include(CTest) # equivalent to "enable_testing() ???
    add_custom_target(check COMMAND ${CMAKE_CTEST_COMMAND} -LE Fullcheck)
       # => 'make check' is an alias for 'ctest'
    add_custom_target(fullcheck COMMAND ${CMAKE_CTEST_COMMAND})
       # => 'make check' is an alias for 'ctest'
endif()


### Operating system and compilation flags

# no support for systems with addresses shorter than 64 bits
if(CMAKE_SIZEOF_VOID_P EQUAL 4)
    message(FATAL "Found a 32bit system - no longer supported")
elseif(CMAKE_SIZEOF_VOID_P LESS 8)
    message(FATAL "Found a ${CMAKE_SIZEOF_VOID_P} byte system - very unexpected and not supported")
endif()

# introduce `LINUX` flag (whereas `APPLE` and `WIN32` are set by CMake)
if(UNIX AND CMAKE_SYSTEM_NAME MATCHES Linux)
    set(LINUX ON)
endif()

# the host system must be Linux, Apple or Windows
if(NOT (LINUX OR APPLE OR WIN32))
    message(FATAL_ERROR "Operating system ${CMAKE_SYSTEM_NAME} is not supported")
endif()

if(LINUX)
    include(cmake/BornAgain/Linux)
elseif(APPLE)
    include(cmake/BornAgain/MacOS)
elseif(WIN32)
    include(cmake/BornAgain/Windows)
endif()

if(CMAKE_CXX_COMPILER_ID MATCHES "Clang")
    set(CLANG ON)
    string(APPEND CMAKE_CXX_FLAGS " -Wno-misleading-indentation")
elseif(CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
    set(GCC ON)
    string(APPEND CMAKE_CXX_FLAGS " -fdiagnostics-color=always")
elseif(NOT WIN32)
    message(FATAL_ERROR "Unsupported compiler, id=${CMAKE_CXX_COMPILER_ID}")
endif()

set(CMAKE_VISIBILITY_INLINES_HIDDEN YES)
if(ZERO_TOLERANCE)
    if (WIN32)
        string(APPEND CMAKE_CXX_FLAGS " /WX")
    else()
        string(APPEND CMAKE_CXX_FLAGS " -Werror")
    endif()
endif()
if(ALGORITHM_DIAGNOSTIC)
    string(APPEND CMAKE_CXX_FLAGS " -DALGORITHM_DIAGNOSTIC=ON")
endif()
string(APPEND CMAKE_CXX_FLAGS_DEBUG " -DBA_DEBUG") # changes behavior of ASSERT

include(cmake/BornAgain/CompilerInfo)

### Further configuration

# function definitions
include(cmake/commons/GetFilenameComponent) # fct get_filename_component (overwrites CMake's built-in)
if(BORNAGAIN_PYTHON)
    include(cmake/multipython/SwigLib) # fct SwigLib
endif()
include(cmake/BornAgain/MakeLib) # fct MakeLib

# main settings
include(cmake/BornAgain/Directories)
include(cmake/BornAgain/FindLibraries)

if(WIN32)
    include(cmake/BornAgain/InstallDll)
endif()

# Python
if(BORNAGAIN_PYTHON)
    include(cmake/multipython/PyDependences)
endif()

if(BA_GUI)
    include(cmake/BornAgain/Qt)
    string(APPEND CMAKE_CXX_FLAGS " -DHAVE_QT=ON")
endif()

include(cmake/BornAgain/ConfigureFiles)

### Configure source components

# library Fit
add_subdirectory(Fit/3rdparty)
add_subdirectory(Fit)

# other components
set(CoreComponents "Base")
if (BORNAGAIN_PYTHON)
    set(CoreComponents "${CoreComponents};PyCore")
endif()
set(CoreComponents "${CoreComponents};Param;Sample;Resample;Device;Sim")
set(AllComponents "${CoreComponents};Img3D;GUI")

# code analysis
if(LINUX AND DEVELOPER_CHECKS)
    include(cmake/BornAgain/SourceChecks)
endif()
if(BA_COVERAGE)
  include(cmake/BornAgain/Coverage)
endif()

# third-party code
add_subdirectory(3rdparty/common)
add_subdirectory(3rdparty/Core)
if(BA_GUI)
    add_subdirectory(3rdparty/GUI/qcustomplot)
endif()

# from here on our own code, occasionally scrutinized by clang-tidy
if(BA_TIDY)
    set(CMAKE_CXX_CLANG_TIDY "clang-tidy") # has effect only if compiler is clang; uses .clang-tidy
endif()

# configure core component libraries
foreach(lib ${CoreComponents})
    add_subdirectory(${lib})
endforeach()
if(BORNAGAIN_PYTHON)
    if (CONFIGURE_EXAMPLES)
        add_subdirectory(rawEx)
    endif()
endif()

# GUI
if(BA_GUI)
    add_subdirectory(Img3D)
    add_subdirectory(GUI)
    add_subdirectory(App)
endif()

# tests
if(BA_TESTS)
    if(BA_3ARCH)
        add_compile_definitions(BA_OTHER_ARCH=ON)
    endif()
    add_subdirectory(Tests/Unit)
    if(BORNAGAIN_PYTHON)
        add_subdirectory(Tests/Examples)
        add_subdirectory(Tests/Py)
    endif()
    add_subdirectory(Tests/SimFactory)
    add_subdirectory(Tests/Functional)
    add_subdirectory(Tests/Suite)
endif()


# documentation
if (BA_DOCS)
    add_subdirectory(Doc/man)

    if(BORNAGAIN_PYTHON AND BA_TESTS)
        # NOTE: target 'figures' is defined in Tests and is needed for the documentation
        add_subdirectory(hugo)
        add_subdirectory(Doc/graph)
    endif()

    if(CONFIGURE_DOXY)
        add_subdirectory(Doc/Doxygen)
    endif()
endif()

# to show CMake and other auxiliary scripts in Qt creator
file(GLOB_RECURSE ScriptFiles cmake/configurables/* deploy/*)
add_custom_target(scripts SOURCES ${ScriptFiles})

### Finalize

# make package targets
include(cmake/BornAgain/Pack)

# local installation (only for Linux)
if(LINUX)
    set(BA_INSTALL_SCRIPT "${CMAKE_BINARY_DIR}/cmake_install.cmake")
    # install only the BornAgain executable, BornAgain libraries and the examples
    add_custom_target(install_local
        COMMAND ${CMAKE_COMMAND} -D COMPONENT=Applications -P ${BA_INSTALL_SCRIPT}
        COMMAND ${CMAKE_COMMAND} -D COMPONENT=Libraries -P ${BA_INSTALL_SCRIPT}
        COMMAND ${CMAKE_COMMAND} -D COMPONENT=Manual -P ${BA_INSTALL_SCRIPT}
        COMMAND ${CMAKE_COMMAND} -D COMPONENT=Examples -P ${BA_INSTALL_SCRIPT}
        )
endif()

# build log
include(cmake/BornAgain/BuildLog)
install(FILES ${BA_BUILD_LOG} DESTINATION ${destination_share})
message(STATUS "BornAgain build log written to '${BA_BUILD_LOG}'")

message(STATUS "CMake done")

=== App/CMakeLists.txt ===
###############################################################################
# Builds BornAgain/GUI main executable
###############################################################################

if(WIN32)
    set(executable_name BornAgain)
else()
    set(executable_name bornagain)
endif()

set(source_files main.cpp AppOptions.cpp)

# -----------------------------------------------------------------------------
# Qt configuration
# -----------------------------------------------------------------------------
set(CMAKE_AUTOMOC ON)

# -----------------------------------------------------------------------------
# executable icons
# -----------------------------------------------------------------------------
if(WIN32)
    set(system_addons bornagain.rc)
    if(NOT win32_console)
        set(executable_options WIN32)
    endif()
endif()

if(APPLE)
    set_source_files_properties(${CMAKE_CURRENT_SOURCE_DIR}/BornAgain.icns
        PROPERTIES MACOSX_PACKAGE_LOCATION Resources)
endif()

# -----------------------------------------------------------------------------
# executable
# -----------------------------------------------------------------------------
add_executable(${executable_name}
    ${executable_options}
    ${source_files}
    ${system_addons})

# -----------------------------------------------------------------------------
# dependencies
# -----------------------------------------------------------------------------
target_link_libraries(${executable_name} PRIVATE BornAgainGUI)
target_include_directories(${executable_name} PRIVATE ${CMAKE_SOURCE_DIR})

# -----------------------------------------------------------------------------
# extra target properties
# -----------------------------------------------------------------------------
if(BORNAGAIN_PYTHON)
    target_compile_definitions(${executable_name} PRIVATE -DBORNAGAIN_PYTHON)
endif()

if(WIN32)
    set_target_properties(${executable_name} PROPERTIES LINK_OPTIONS /ENTRY:mainCRTStartup)
    if(win32_console)
        set_target_properties(${executable_name} PROPERTIES COMPILE_DEFINITIONS _CONSOLE)
    endif()
endif()

# -----------------------------------------------------------------------------
# runtime library paths
# -----------------------------------------------------------------------------
#   See our deployment paper (Nejati et al 2024) for explanation.

if(LINUX)
    # NOTE: RPATH must be set also in `GUI/CMakeLists.txt`
    set(link_flags "-Wl,-rpath,\$ORIGIN/../lib")
    set_target_properties(${executable_name} PROPERTIES LINK_FLAGS ${link_flags})
elseif(APPLE)
    set(link_flags "-Wl,-rpath,@loader_path/../lib/")
    set_target_properties(${executable_name} PROPERTIES LINK_FLAGS ${link_flags})
endif()

# -----------------------------------------------------------------------------
# installation section
# -----------------------------------------------------------------------------
install(TARGETS ${executable_name} RUNTIME DESTINATION ${destination_bin}
    COMPONENT Applications)

set(image_files
    ${CMAKE_CURRENT_SOURCE_DIR}/BornAgain.ico
    ${CMAKE_CURRENT_SOURCE_DIR}/BornAgain.icns
    ${CMAKE_SOURCE_DIR}/GUI/images/BornAgain_48x48.png
    ${CMAKE_SOURCE_DIR}/GUI/images/BornAgain_64x64.png)
install(FILES ${image_files} DESTINATION ${destination_images} COMPONENT Applications)

# -----------------------------------------------------------------------------
# system dependent installation
# -----------------------------------------------------------------------------
if(WIN32)
    message(STATUS "Configuring the GUI package")

    foreach(comp ${QtComponents})
        set(QtComp Qt6::${comp})
        get_target_property(dll ${QtComp} LOCATION_Release)
        get_property(dll TARGET ${QtComp} PROPERTY LOCATION_Release)
        install(FILES ${dll} DESTINATION ${destination_lib} COMPONENT WinLibraries)
        message(STATUS "Install Qt lib ${QtComp} (${dll})")
    endforeach()

    # extract Qt root-dir
    # 'C:/Qt/6.2.4/msvc2019_64/lib/cmake/Qt6' => 'C:/Qt/6.2.4/msvc2019_64'
    file(TO_CMAKE_PATH "${Qt_DIR}" qt_dir_str)

    install(FILES ${Qt_DIR}/bin/opengl32sw.dll
        DESTINATION ${destination_lib}
        COMPONENT WinLibraries)
    install(FILES ${Qt_PLUGINS_DIR}/platforms/qwindows.dll
        DESTINATION bin/platforms
        COMPONENT WinLibraries)
    install(FILES ${Qt_PLUGINS_DIR}/iconengines/qsvgicon.dll
        DESTINATION bin/iconengines
        COMPONENT WinLibraries)
    install(FILES ${Qt_PLUGINS_DIR}/imageformats/qjpeg.dll ${Qt_PLUGINS_DIR}/imageformats/qsvg.dll
        DESTINATION bin/imageformats
        COMPONENT WinLibraries)

    set(QT_VISTA_STYLE ${Qt_PLUGINS_DIR}/styles/qwindowsvistastyle.dll)
    if(EXISTS ${QT_VISTA_STYLE})
        install(FILES ${QT_VISTA_STYLE} DESTINATION bin/styles COMPONENT WinLibraries)
    else()
        message(AUTHOR_WARNING File ${QT_VISTA_STYLE} not found.)
    endif()
    unset(QT_VISTA_STYLE)
endif()

if(LINUX)
    set(LINUXPKG_MAIN_EXE "${CMAKE_BINARY_DIR}/bin/${executable_name}")
    set(LINUXPKG_FRAMEWORK_DEST "${destination_lib}")

    configure_file(${CMAKE_SOURCE_DIR}/deploy/linux/adjust_pkg_linux.sh.in
        ${BUILD_VAR_DIR}/adjust_pkg_linux.sh @ONLY)
endif()

# execute package-fixing script before CPack builds the final package file
configure_file(${CMAKE_SOURCE_DIR}/cmake/configurables/FixPack.cmake.in
    ${BUILD_VAR_DIR}/FixPack.cmake @ONLY)

install(SCRIPT ${BUILD_VAR_DIR}/FixPack.cmake)

=== Device/CMakeLists.txt ===
############################################################################
# CMakeLists.txt file for building libBornAgainDevice
############################################################################

set(component Device)
set(lib BornAgain${component})

# --- source and include files ---

file(GLOB source_files */*.cpp)
file(GLOB include_files RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} */*.h)

# --- make the library ---

add_library(${lib} SHARED)
MakeLib(${lib} "${CMAKE_CURRENT_BINARY_DIR}/Wrap" "${source_files}" "${include_files}")

# --- external dependencies ---

target_link_libraries(${lib}
    PUBLIC
    BornAgainBase
    BornAgainFit
    BornAgainParam
    BornAgainSample
    BornAgainResample
    ${CMAKE_THREAD_LIBS_INIT}
    ${tspectrum_LIBRARY}
    ${ZLIB_LIBRARIES}
    ${BZIP2_LIBRARIES}
)
if(BORNAGAIN_PYTHON)
    target_link_libraries(${lib} PUBLIC BornAgainPyCore)
endif()

target_include_directories(${lib}
    PUBLIC
    ${CMAKE_SOURCE_DIR}
)

target_include_directories(${lib} SYSTEM
    PUBLIC
    ${tspectrum_INCLUDE_DIR}
    ${ZLIB_INCLUDE_DIRS}
    ${BZIP2_INCLUDE_DIRS}
)

if(BA_TIFF_SUPPORT)
    target_link_libraries(${lib} PUBLIC ${TIFF_LIBRARIES})
    target_include_directories(${lib} PUBLIC ${TIFF_INCLUDE_DIR})
    target_compile_definitions(${lib} PUBLIC -DBA_TIFF_SUPPORT)
endif()

if(WIN32)
    target_compile_definitions(${lib} PRIVATE -DBA_DEVICE_BUILD_DLL)
endif()

=== GUI/CMakeLists.txt ===
############################################################################
# CMakeLists.txt file for building BornAgain/GUI libraries and executable
############################################################################

message(STATUS "Configuring BornAgain GUI")

set(CMAKE_AUTOMOC ON)

set(lib BornAgainGUI)

# --- source and include files ---

file(GLOB_RECURSE source_files *.cpp)

set(resource_files gui.qrc)

# --- Qt configuration ---------

qt_add_resources(RC_SRCS ${resource_files})

# --- make the library ---------

add_library(${lib} SHARED ${source_files} ${RC_SRCS} ${include_files})
#set_target_properties(${lib} PROPERTIES PREFIX ${libprefix} SUFFIX ${libsuffix})

get_target_property(lib_dir ${lib} LIBRARY_OUTPUT_DIRECTORY)
set(BornAgain_LIBRARIES "$CACHE{BornAgain_LIBRARIES};${lib_dir}/${libprefix}${lib}${libsuffix}"
    CACHE INTERNAL "BornAgain libraries")

# switch OFF Qt debug output in any configuration except DEBUG
target_compile_definitions(${lib} PUBLIC $<$<NOT:$<CONFIG:Debug>>:QT_NO_DEBUG_OUTPUT>)

# -----------------------------------------------------------------------------
# runtime library paths
# -----------------------------------------------------------------------------
#   See our deployment paper (Nejati et al 2024) for explanation.

if(LINUX)
    # NOTE: RPATH must be set also in `App/CMakeLists.txt`
    set(link_flags "-Wl,--disable-new-dtags,-rpath,\$ORIGIN")
    set_target_properties(${lib} PROPERTIES LINK_FLAGS ${link_flags})
endif(LINUX)

if(BORNAGAIN_PYTHON)
    target_compile_definitions(${lib} PRIVATE -DBORNAGAIN_PYTHON)
endif()

# --- external dependences ---------

target_link_libraries(${lib}
    PUBLIC
    BornAgainSim
    BornAgainImg3D
    Qt6::Widgets
    Qt6::Core
    Qt6::Gui
    Qt6::OpenGLWidgets
    PRIVATE
    Qt6::PrintSupport
    qcustomplot
)
if(BORNAGAIN_PYTHON)
    target_link_libraries(${lib} PUBLIC BornAgainPyCore)
endif()
target_include_directories(${lib} PUBLIC
    ${CMAKE_SOURCE_DIR}
    ${CMAKE_SOURCE_DIR}/3rdparty/GUI/qcustomplot
)

if(WIN32)
    target_compile_definitions(${lib} PRIVATE -DBA_GUI_BUILD_DLL)
endif()

if(BA_CRASHHANDLER)
    target_compile_definitions(${lib} PRIVATE -DBA_CRASHHANDLER)
endif()

# --- installation ---------

set_target_properties(${lib} PROPERTIES
    PREFIX ${libprefix}
    SUFFIX ${libsuffix}
    OUTPUT_NAME ${lib}
    )

install(TARGETS ${lib}
    LIBRARY DESTINATION ${destination_lib} COMPONENT Libraries
    RUNTIME DESTINATION ${destination_lib} COMPONENT Libraries)

=== Img3D/CMakeLists.txt ===
set(lib BornAgainImg3D)

set(CMAKE_AUTOMOC ON)

file(GLOB_RECURSE source_files *.cpp)

set(CMAKE_AUTORCC ON)
qt_add_resources(RC_SHADERS shaders.qrc)

add_library(${lib} STATIC ${source_files} ${RC_SHADERS})

target_include_directories(${lib}
    PUBLIC
    ${CMAKE_SOURCE_DIR}
)

target_include_directories(${lib} SYSTEM
    PUBLIC
    ${LibHeinz_INCLUDE_DIR}
    ${formfactor_INCLUDE_DIR}
)

target_link_libraries(${lib} Qt6::Core Qt6::Widgets Qt6::OpenGL Qt6::OpenGLWidgets)

=== Param/CMakeLists.txt ===
############################################################################
# CMakeLists.txt file for building libBornAgainParam
############################################################################

set(component Param)
set(lib BornAgain${component})

# --- source and include files ---

file(GLOB source_files */*.cpp)
file(GLOB include_files RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} */*.h)

# --- make the library ---

add_library(${lib} SHARED)
MakeLib(${lib} "${CMAKE_CURRENT_BINARY_DIR}/Wrap" "${source_files}" "${include_files}")

# --- external dependences ---

target_link_libraries(${lib}
    PUBLIC
    BornAgainBase
    BornAgainFit
    )
target_include_directories(${lib}
    PUBLIC
    ${CMAKE_SOURCE_DIR}
    )

=== PyCore/CMakeLists.txt ===
############################################################################
# CMakeLists.txt file for building libBornAgainPyCore
############################################################################

# NOTE: The module is directly dependent on Python C-API
if(NOT BORNAGAIN_PYTHON)
    message(FATAL_ERROR "PyCore module requested although BORNAGAIN_PYTHON=false")
endif()

set(component PyCore)
set(lib BornAgain${component})

# --- source and include files ---
# Python-dependent source files
file(GLOB_RECURSE source_files */*.cpp)
file(GLOB_RECURSE include_files RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} */*.h)

# --- make the library ---

add_library(${lib} SHARED)
MakeLib(${lib} "" "${source_files}" "${include_files}")

# --- external dependences ---

target_link_libraries(${lib}
    PUBLIC
    ${Python3_LIBRARIES}
)
target_include_directories(${lib}
    PRIVATE
    ${CMAKE_SOURCE_DIR}
    ${LibHeinz_INCLUDE_DIR}
    ${Python3_INCLUDE_DIRS}
)

=== Resample/CMakeLists.txt ===
############################################################################
# CMakeLists.txt file for building libBornAgainResample
############################################################################

set(component Resample)
set(lib BornAgain${component})

# --- source and include files ---

file(GLOB source_files */*.cpp)
file(GLOB include_files RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} */*.h)

# --- make the library ---

add_library(${lib} SHARED)
MakeLib(${lib} "${CMAKE_CURRENT_BINARY_DIR}/Wrap" "${source_files}" "${include_files}")

# --- external dependences ---

target_link_libraries(${lib}
    PUBLIC
    BornAgainSample
    )
target_include_directories(${lib}
    PUBLIC
    ${CMAKE_SOURCE_DIR}
    )

=== Sample/CMakeLists.txt ===
############################################################################
# CMakeLists.txt file for building libBornAgainSample
############################################################################

set(component Sample)
set(lib BornAgain${component})

# --- source and include files ---

file(GLOB source_files */*.cpp)
file(GLOB include_files RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} */*.h)

# --- make the library ---

add_library(${lib} SHARED)
MakeLib(${lib} "${CMAKE_CURRENT_BINARY_DIR}/Wrap" "${source_files}" "${include_files}")

# --- external dependences ---

target_link_libraries(${lib}
    PUBLIC
    BornAgainParam
    formfactor
    )
target_include_directories(${lib}
    PUBLIC
    ${CMAKE_SOURCE_DIR}
    ${formfactor_INCLUDE_DIR}
    )
    
if(BORNAGAIN_PYTHON)
    target_link_libraries(${lib} PUBLIC BornAgainPyCore)
endif()

=== Sim/CMakeLists.txt ===
############################################################################
# CMakeLists.txt file for building libBornAgainSim
############################################################################

set(component Sim)
set(lib BornAgain${component})

# --- source and include files ---

file(GLOB source_files */*.cpp)
file(GLOB include_files RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} */*.h)

# --- make the library ---

add_library(${lib} SHARED)
MakeLib(${lib} "${CMAKE_CURRENT_BINARY_DIR}/Wrap" "${source_files}" "${include_files}")

# --- external dependences ---

target_link_libraries(${lib}
    PUBLIC
    BornAgainSample
    BornAgainDevice
    PRIVATE
    BornAgainResample
    ${CMAKE_THREAD_LIBS_INIT}
    ${cerf_target})

target_include_directories(${lib}
    PUBLIC
    ${CMAKE_SOURCE_DIR}
    ${CMAKE_SOURCE_DIR}/3rdparty/Core/ # needed for cerfcpp header
    )

=== hugo/CMakeLists.txt ===
add_custom_target(hugo COMMAND hugo WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}/hugo)
add_dependencies(hugo excopy figures)
# Build targets excopy and figures populate hugo/static/(img|py)/auto;
# build target hugo copies them from hugo/static/(img|py) to hugo/public/(img|py).

# The following is needed to decouple top-level target webdoc from hugo;
# empirically, without this, the dependence of hugo on excopy and figures is not respected.
add_custom_target(webdoc)
add_dependencies(webdoc hugo)

=== rawEx/CMakeLists.txt ===
if(NOT CONFIGURE_EXAMPLES)
    message(FATAL_ERROR "Invalid call w/o CONFIGURE_EXAMPLES")
endif()

file(GLOB_RECURSE examples *.py)

unset(outputs)
foreach(ex ${examples})
    cmake_path(GET ex FILENAME ex_name )
    cmake_path(GET ex PARENT_PATH in_path)

    # Configure the public version of examples.
    string(REPLACE ${EXAMPLES_SRC_DIR} ${EXAMPLES_PUBL_DIR} out_path ${in_path})
    file(MAKE_DIRECTORY ${out_path})
    set(ex_out ${out_path}/${ex_name})
    add_custom_command(
        OUTPUT ${ex_out}
        COMMAND erb -T - ${CMAKE_CURRENT_SOURCE_DIR}/publicmode.erb ${ex} > ${ex_out}
        COMMAND chmod a+x ${ex_out}
        DEPENDS ${ex}
    )
    list(APPEND outputs ${ex_out})

    # Configure testable version of examples.
    # Tests will be configured by <ba>/Tests/Examples/CMakeLists.txt.
    string(REPLACE ${EXAMPLES_SRC_DIR} ${EXAMPLES_TEST_DIR} out_path ${in_path})
    file(MAKE_DIRECTORY ${out_path})
    set(ex_out ${out_path}/${ex_name})
    add_custom_command(
        OUTPUT ${ex_out}
        COMMAND erb -T - ${CMAKE_CURRENT_SOURCE_DIR}/testmode.erb ${ex} > ${ex_out}
        COMMAND chmod a+x ${ex_out}
        DEPENDS ${ex}
    )
    list(APPEND outputs ${ex_out})

    # Configure the version of examples to produce documentation figures.
    string(REPLACE ${EXAMPLES_SRC_DIR} ${EXAMPLES_FIGURES_DIR} out_path ${in_path})
    file(MAKE_DIRECTORY ${out_path})
    set(ex_out ${out_path}/${ex_name})
    add_custom_command(
        OUTPUT ${ex_out}
        COMMAND erb -T - ${CMAKE_CURRENT_SOURCE_DIR}/figuremode.erb ${ex} > ${ex_out}
        COMMAND chmod a+x ${ex_out}
        DEPENDS ${ex}
    )
    list(APPEND outputs ${ex_out})

endforeach()

add_custom_target(configured_examples ALL DEPENDS ${outputs})

=== debian/changelog ===
bornagain (23.0-6) unstable; urgency=medium

  * d/test/gui: check that bornagain start without error.
  * Bug fix: "cannot open shared object file: No such file or directory",
    thanks to Frederic-Emmanuel Picca (Closes: #1126534).
  * Bug fix: "move from twitter-bootstrap{3,4} to bootstrap-html (v5)",
    thanks to santiagorr@riseup.net</a>; (Closes: #1088448).

 -- Picca Frédéric-Emmanuel <picca@debian.org>  Tue, 10 Feb 2026 16:28:12 +0100

bornagain (23.0-5) unstable; urgency=medium

  * Team upload.
  * Only test against default Python interpreter (Closes: #1125743).
  * Drop unneeded Priority:optional and R3:no fields.
  * Update Standards-Version to 4.7.3 (no changes required).
  * Override some lintian noise to improve usefulness of output.

 -- Stuart Prescott <stuart@debian.org>  Wed, 21 Jan 2026 12:49:37 +1100

bornagain (23.0-4) unstable; urgency=medium

  * Loosen tolerance a bit for one test.

 -- Roland Mas <lolando@debian.org>  Fri, 15 Aug 2025 17:33:36 +0200

bornagain (23.0-3) unstable; urgency=medium

  * Fix arch:all-only builds.

 -- Roland Mas <lolando@debian.org>  Fri, 15 Aug 2025 15:36:56 +0200

bornagain (23.0-2) unstable; urgency=medium

  * Versioned build-depends on libcerf-dev.

 -- Roland Mas <lolando@debian.org>  Wed, 13 Aug 2025 17:37:46 +0200

bornagain (23.0-1) unstable; urgency=medium

  * New upstream release.

 -- Roland Mas <lolando@debian.org>  Wed, 13 Aug 2025 15:41:22 +0200

=== debian/control ===
Source: bornagain
Maintainer: Debian PaN Maintainers <debian-pan-maintainers@alioth-lists.debian.net>
Uploaders:
 Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>,
 Mika Pflüger <debian@mikapflueger.de>,
 Picca Frédéric-Emmanuel <picca@debian.org>,
 Roland Mas <lolando@debian.org>,
Section: science
Build-Depends:
 clang-format <!nocheck>,
 cmake,
 debhelper-compat (= 13),
 dh-sequence-numpy3,
 dh-sequence-python3,
 doxygen-latex <!nodoc>,
 graphviz <!nodoc>,
 libboost-all-dev,
 libbz2-dev,
 libcerf-dev (>= 3.1),
 libeigen3-dev,
 libfftw3-dev,
 libformfactor-dev,
 libgsl0-dev,
 libheinz-dev,
 libqt6opengl6-dev,
 libtiff-dev,
 libxkbcommon-dev,
 libyaml-cpp-dev,
 python3-corner <!nopython>,
 python3-dev <!nopython>,
 python3-emcee <!nopython>,
 python3-fabio <!nopython>,
 python3-lmfit <!nopython>,
 python3-matplotlib <!nopython>,
 python3-numpy <!nopython>,
 python3-pip <!nopython>,
 python3-scipy <!nopython>,
 python3-setuptools <!nopython>,
 python3-yaml <!nopython>,
 qt6-base-dev,
 qt6-svg-dev,
 swig <!nopython>,
Build-Depends-Indep:
 hugo <!nodoc>,
 texlive-fonts-extra <!nodoc>,
 texlive-xetex <!nodoc>,
Standards-Version: 4.7.3
Vcs-Browser: https://salsa.debian.org/science-team/bornagain
Vcs-Git: https://salsa.debian.org/science-team/bornagain.git
Homepage: https://bornagainproject.org/

Package: bornagain
Architecture: amd64 arm64 armel armhf mips64el ppc64el riscv64 s390x loong64 ppc64 sparc64
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Recommends:
 python3-bornagain,
Description: Simulate and fit X-ray and neutron GISAS -- binary
 BornAgain is a software package to simulate and fit small-angle scattering at
 grazing incidence. It supports analysis of both X-ray (GISAXS) and neutron
 (GISANS) data. Calculations are carried out in the framework of the distorted
 wave Born approximation (DWBA). BornAgain provides a graphical user interface
 for interactive use as well as a generic Python and C++ framework for modeling
 multilayer samples with smooth or rough interfaces and with various types of
 embedded nanoparticles.
 .
 BornAgain supports:
 .
 Layers:
  * Multilayers without any restrictions on the number of layers
  * Interface roughness correlation
  * Magnetic materials
 .
 Particles:
  * Choice between different shapes of particles (form factors)
  * Particles with inner structures
  * Assemblies of particles
  * Size distribution of the particles (polydispersity)
 .
 Positions of Particles:
  * Decoupled implementations between vertical and planar positions
  * Vertical distributions: particles at specific depth in layers or on top.
  * Planar distributions:
    - fully disordered systems
    - short-range order distribution (paracrystals)
    - two- and one-dimensional lattices
 .
 Input Beam:
  * Polarized or unpolarized neutrons
  * X-ray
  * Divergence of the input beam (wavelength, incident angles) following
    different distributions
  * Possible normalization of the input intensity
 .
 Detector:
  * Off specular scattering
  * Two-dimensional intensity matrix, function of the output angles
 .
 Use of BornAgain:
  * Simulation of GISAXS and GISANS from the generated sample
  * Fitting to reference data (experimental or numerical)
  * Interactions via Python scripts or Graphical User Interface
 .
 If you use BornAgain in your work, please cite
  C. Durniak, M. Ganeva, G. Pospelov, W. Van Herck, J. Wuttke (2015), BornAgain
  — Software for simulating and fitting X-ray and neutron small-angle
  scattering at grazing incidence, version <version you used>,
  http://www.bornagainproject.org

Package: python3-bornagain
Architecture: amd64 arm64 armel armhf mips64el ppc64el riscv64 s390x loong64 ppc64 sparc64
Depends:
 python3-matplotlib,
 python3-numpy,
 python3-yaml,
 ${misc:Depends},
 ${python3:Depends},
 ${shlibs:Depends},
Description: Simulate and fit X-ray and neutron GISAS -- Python3
 BornAgain is a software package to simulate and fit small-angle scattering at
 grazing incidence. It supports analysis of both X-ray (GISAXS) and neutron
 (GISANS) data. Calculations are carried out in the framework of the distorted
 wave Born approximation (DWBA). BornAgain provides a graphical user interface
 for interactive use as well as a generic Python and C++ framework for modeling
 multilayer samples with smooth or rough interfaces and with various types of
 embedded nanoparticles.
 .
 BornAgain supports:
 .
 Layers:
  * Multilayers without any restrictions on the number of layers
  * Interface roughness correlation
  * Magnetic materials
 .
 Particles:
  * Choice between different shapes of particles (form factors)
  * Particles with inner structures
  * Assemblies of particles
  * Size distribution of the particles (polydispersity)
 .
 Positions of Particles:
  * Decoupled implementations between vertical and planar positions
  * Vertical distributions: particles at specific depth in layers or on top.
  * Planar distributions:
    - fully disordered systems
    - short-range order distribution (paracrystals)
    - two- and one-dimensional lattices
 .
 Input Beam:
  * Polarized or unpolarized neutrons
  * X-ray
  * Divergence of the input beam (wavelength, incident angles) following
    different distributions
  * Possible normalization of the input intensity
 .
 Detector:
  * Off specular scattering
  * Two-dimensional intensity matrix, function of the output angles
 .
 Use of BornAgain:
  * Simulation of GISAXS and GISANS from the generated sample
  * Fitting to reference data (experimental or numerical)
  * Interactions via Python scripts or Graphical User Interface
 .
 If you use BornAgain in your work, please cite
  C. Durniak, M. Ganeva, G. Pospelov, W. Van Herck, J. Wuttke (2015), BornAgain
  — Software for simulating and fitting X-ray and neutron small-angle
  scattering at grazing incidence, version <version you used>,
  http://www.bornagainproject.org
 .
  This package contains the Python bindings for use in scripts.

Package: bornagain-doc
Architecture: all
Section: doc
Depends:
 fonts-font-awesome,
 fonts-open-sans,
 fonts-roboto,
 libjs-bootstrap5,
 libjs-jquery,
 libjs-popper.js,
 ${misc:Depends},
 ${shlibs:Depends},
Recommends:
 bornagain,
Multi-Arch: foreign
Description: Simulate and fit X-ray and neutron GISAS -- doc
 BornAgain is a software package to simulate and fit small-angle scattering at
 grazing incidence. It supports analysis of both X-ray (GISAXS) and neutron
 (GISANS) data. Calculations are carried out in the framework of the distorted
 wave Born approximation (DWBA). BornAgain provides a graphical user interface
 for interactive use as well as a generic Python and C++ framework for modeling
 multilayer samples with smooth or rough interfaces and with various types of
 embedded nanoparticles.
 .
 BornAgain supports:
 .
 Layers:
  * Multilayers without any restrictions on the number of layers
  * Interface roughness correlation
  * Magnetic materials
 .
 Particles:
  * Choice between different shapes of particles (form factors)
  * Particles with inner structures
  * Assemblies of particles
  * Size distribution of the particles (polydispersity)
 .
 Positions of Particles:
  * Decoupled implementations between vertical and planar positions
  * Vertical distributions: particles at specific depth in layers or on top.
  * Planar distributions:
    - fully disordered systems
    - short-range order distribution (paracrystals)
    - two- and one-dimensional lattices
 .
 Input Beam:
  * Polarized or unpolarized neutrons
  * X-ray
  * Divergence of the input beam (wavelength, incident angles) following
    different distributions
  * Possible normalization of the input intensity
 .
 Detector:
  * Off specular scattering
  * Two-dimensional intensity matrix, function of the output angles
 .
 Use of BornAgain:
  * Simulation of GISAXS and GISANS from the generated sample
  * Fitting to reference data (experimental or numerical)
  * Interactions via Python scripts or Graphical User Interface
 .
 If you use BornAgain in your work, please cite
  C. Durniak, M. Ganeva, G. Pospelov, W. Van Herck, J. Wuttke (2015), BornAgain
  — Software for simulating and fitting X-ray and neutron small-angle
  scattering at grazing incidence, version <version you used>,
  http://www.bornagainproject.org
 .
  This package contains the BornAgain documentation.

=== debian/rules ===
#!/usr/bin/make -f
# output every command that modifies files on the build system.
export DH_VERBOSE = 1

# deal with profiles
CONFIG_SWITCHES=-DCMAKE_DEB_HOST_MULTIARCH=$(DEB_HOST_MULTIARCH)

ifneq ($(filter nodoc,$(DEB_BUILD_PROFILES)),)
	CONFIG_SWITCHES += -DCONFIGURE_DOXY=OFF
else
	CONFIG_SWITCHES += -DCONFIGURE_DOXY=ON
endif

ifneq ($(filter nopython,$(DEB_BUILD_PROFILES)),)
	CONFIG_SWITCHES += -DBORNAGAIN_PYTHON=OFF -DCONFIGURE_BINDINGS=OFF
else
	CONFIG_SWITCHES += -DBORNAGAIN_PYTHON=ON -DCONFIGURE_BINDINGS=ON
endif

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk
CFLAGS+=$(CPPFLAGS)
CXXFLAGS+=$(CPPFLAGS)

export CMAKE_OPTIONS := \
  -DCMAKE_CXX_FLAGS="$(CXXFLAGS)" \
  -DCMAKE_SHARED_LINKER_FLAGS_RELEASE="$(LDFLAGS)" \
  -DCMAKE_PREFIX_PATH="/usr/share/cmake/heinz;/usr/share/cmake/formfactor" \
  -DCMAKE_LIBRARY_PATH=/usr/lib/$(DEB_HOST_MULTIARCH)/bornagain \
  -DCMAKE_BUILD_TYPE=Release \
  -DBA_3ARCH=ON

%:
	dh $@

execute_after_dh_clean:
	find auto -name *.pyc -delete

override_dh_auto_configure:
	dh_auto_configure -- $(CMAKE_OPTIONS) $(CONFIG_SWITCHES) -DCMAKE_LIBRARY_PATH=$(DEB_HOST_MULTIARCH)

override_dh_auto_test: export MPLCONFIGDIR=$(CURDIR)
override_dh_auto_test:
	cd obj-$(DEB_HOST_GNU_TYPE) && make -j test ARGS\+=--verbose ARGS\+=-j

override_dh_auto_build-arch:
	dh_auto_build

override_dh_auto_build-indep:
	dh_auto_build
	cd hugo && hugo

execute_after_dh_auto_install:
	find debian/tmp -name __pycache__ | xargs -r rm -r
	rm -f debian/tmp/usr/share/BornAgain/bornagain_build.log

execute_after_dh_install-arch:
	find debian/python3-bornagain -name _libBornAgainGUI.so -delete

override_dh_shlibdeps:
	dh_shlibdeps -l /usr/lib/$(DEB_HOST_GNU_TYPE)/bornagain/

=== debian/tests/control ===
Tests: python3
Depends:
 python3,
 python3-bornagain,
Restrictions: allow-stderr

Test-Command: xvfb-run -s "-screen 0 1024x768x24 -ac +extension GLX +render -noreset" sh debian/tests/gui
Depends:
 bornagain,
 debhelper,
 mesa-utils,
 xauth,
 xvfb,
Restrictions: allow-stderr
